/*
  Designed by LinJiangHua(xempo) 2003-2006,
  Copyright 2004-2006,2008-2010 Linjianghua(xempo).
  All Rights Reserve.
*/

#include "storplus.def"

void MAUfree(MAU *send,int cn)
{
int n;
for(n=0;n<cn;n++)if(send[n].buf)free(send[n].buf);
}

bool NamStrCpy(char *dirnam,const char *dat,int len)
{
char *pt;
static const char namelmt[22]={ '\\', '/', ';', ',', '*', 9, 10, 13, 26, 32,
'?', ':', '\"', '\'', '[', ']', '=','<', '>' };
if(*dat==0||*dat=='-'||*dat=='.'||strchrs(dat,namelmt)||
  (pt=strstr(dat,".."))!=NULL&&pt[2]!='\\'){ DysMsg=9; return false; }
memcpy(dirnam,dat,len);
dirnam[len]=0;
/* because clean code, disk must record '\0' */
return true;
}

long SeekAdr(Dysto *dys,DIRE *curdir,DIRE *creatDir,long *sendadr)
{
long adr, pDir=*sendadr;
DIRE dirbuf;
do {
	adr=pDir;
	if(curdir&&pDir==curdir->selfaddr)dirbuf=*curdir;
	else dkread(dys,&dirbuf,dys->DirSize,1,adr);

	if(dirbuf.usemsg!=1&&creatDir->selfaddr==0&&_CurDate(dys->mdf)-dirbuf.date>0xffff){
		creatDir->nx=dirbuf.nx;
		creatDir->selfaddr=dirbuf.selfaddr;
		break;
		}
  }while((pDir=dirbuf.nx)>0);
*sendadr=dirbuf.selfaddr;
return adr;
}

DIRE *DirCreat(Dysto *dys,const char *Dirnm,BYTE clen,BYTE cnt,bool datelog)
{
/* if dirnam[0]='\\' then Dir would be head Dirs's sub, ='*' is parent Dir
clen is Dir cellLen */
DIRE *pcDir, *creatDir=NULL;
static const int clens[5]={13,sg_dat,21,ml_dat },
	orgclen[3]={sg_dat,ml_dat };
if(Dirnm==NULL/*||Dirnm[0]==0*/){ DysMsg=9; return NULL;	}
pcDir=PathSeek(dys,Dirnm);/* get create Dir's parent */

if(DysMsg>0x7ffd/*||cDir*/){
long adr, pDir;
char *dirnam;
DIRE *curdir=dys->cDir;
creatDir=DIRalloc();

dirnam = strrchr(Dirnm,'\\');
dirnam = dirnam==NULL? (char *)Dirnm:dirnam+1;
 if(NamStrCpy(creatDir->name,dirnam,dys->verNo? DirNamLen:18)){
  pDir = GetAddress(dys,pcDir);
/*------------ get disk(file) pos<adr> for newdir ----------*/
  adr=pDir? SeekAdr(dys,curdir,creatDir,&pDir):0;

/* get disk(file) pos<adr> for newdir, NOT CHK dir wether exist */
/*  if(pDir>0){ DysMsg=10;free(creatDir);return NULL;	}*/

  if(creatDir->selfaddr==0){
	creatDir->selfaddr=dys->fsz;
	if(adr){
	  if(curdir&&curdir->selfaddr==adr){
	    curdir->nx=dys->fsz;/* Set current Dir nx*/
	    curdir->mdf|=1;
	  }
	  else dkwrite(dys,&dys->fsz,4,adr+DirNX);
	goto _skp_;
	}
  }
  if(dys->DirAdr==0)dys->DirAdr=dys->fsz;

_skp_:  dys->mdf|=1; dys->DirCnt++;
/*--------------------------------------*/
  if(clen==0)clen=1;
  creatDir->PreAlloc=cnt? cnt:8;
  creatDir->datelog=datelog;

  creatDir->Format=dys->verNo>2? clen :
  (isdone(clen,dys->verNo? clens:orgclen)? clen:(clen>sg_dat? ml_dat:sg_dat));
  creatDir->usemsg=1;
  if(pcDir){
     pcDir->mdf|=1;
     creatDir->parDir=pcDir->selfaddr;
     if(dys->verNo)pcDir->dircnt++;
     pcDir->sz+=dys->DirSize;
     if(pcDir->subDir==0)pcDir->subDir=creatDir->selfaddr;
  }
  else dys->rootcn++;

  dys->fsz+=dys->DirSize; /*	Dir->sz=0; !=DirSize; Dir->nmbadr  ==0 */
  dys->use+=dys->DirSize;
  creatDir->tag=2;/* must for org */
  creatDir->date=_CurDate(dys->mdf);
  dkwrite(dys,creatDir,dys->DirSize,creatDir->selfaddr);
 }
 else {
	free(creatDir);
	creatDir=NULL;
	}
 Release(dys,pcDir);
}
return creatDir;
}

char WBR[]="wb+";
Dysto *_Create(const char *fname,unsigned idx)
{
char buf[34], mode;
FILE *fp;
Dysto *lib;
if((fp=fopen(fname,WBR))==NULL){
	KShowMsg(fname,plusInfo[3],1);
	return NULL;
	}
lib=DSLalloc();
if(idx>VerLmt)idx=VerLmt;
strcpy(buf,dysTag[idx/*<3? 1:2*/]);
strcpy(lib->vers,dysfver[idx]);

strcpy(_GetVer(buf,Verchs,&mode),lib->vers);

*(long *)(buf+24)=*(long *)__ver[idx];
fwrite(buf,BSlen,1,fp);
*(long *)lib=*(long *)(buf+24);

lib->fsz=BSlen + buf[25];
lib->fname=strdup(fname);
lib->mdf=129;/* perhan not create dir */
lib->cmprSiz=10240;
lib->creatime=_CurDate(128);
lib->fpt=fp;
return lib;
}

static const char CmprsTmp[]="cmpr_tmp.&1~";
static Dysto *_cmp;

void NumbDup(Dysto *dys,DIRE *dir,char *pm)
{
int cn=dir->dau;
MAU *pdat=MAUalloc(cn);
GetDAUs(dys,dir,pm,pdat,cn);
SetNumb(_cmp,_cmp->cDir,*(long *)pm,pdat,cn,1);
MAUfree(pdat,cn);
free(pdat);
}

int _rebuild(Dysto *dys,DIRE *dir,void *pm)
{
char *pName;
int rt;
if((pName=RSeekDir(dys,dir,1))!=NULL){
  Dysto *cmp=pm;
  cmp->cDir=DirCreat(cmp,pName,dir->Format,dir->PreAlloc,dir->datelog);
  DirInit(cmp,cmp->cDir);
  free(pName);
  if(StatLoop(dys,dir,NumbDup)>0)goto wrong;
  _release(cmp,cmp->cDir); 
  cmp->cDir=NULL; /* must set NULL */
	}
else { wrong: rt=popMsg("Continue? y/n/Esc",plusInfo[DysMsg],_Quest_); 
	if(rt!='y')return 1; 
	}
return -1; /* continue all */
}

Dysto *Rebuild(Dysto *dys,const char *fnam)
{
int rt;
printf("\tRebuild ...");
if(!fnam)fnam=CmprsTmp;
if((_cmp=_Create(fnam,dys->verNo))!=NULL){
  rt=DirExpr(dys,dys->DirAdr,_rebuild,_cmp);
  Destory(_cmp,NULL);
  if(rt>0)goto Error;
  if(fnam==CmprsTmp){
	char *pfn=strdup(dys->fname);
	Destory(dys,NULL);
	remove(pfn);
	rename(CmprsTmp,pfn);
	dys=Instance(pfn,0);
	free(pfn);
  }
}
else Error: ErrStyleOut("Fail to rebuild");
return dys;
}